#!/usr/bin/env ruby
#based on http://www.tldp.org/HOWTO/NCURSES-Programming-HOWTO/scanw.html
require 'ncurses'
msg = "Enter a string:"
begin
	#getmaxyx takes empty arrays as argument
	row=col=[]
	#Initialise the string that Ncurses.getstr has to use.
	str = String.new
	
	Ncurses.initscr
	#Get number of rows and columns. Both are arrays, that seem equals to me... 
	#(first element=number of rows, second element =number of columns)
	Ncurses.stdscr.getmaxyx(row,col)
	
	
	#Print message at the center of the screen
	Ncurses.mvprintw(row[0]/2,(col[1]-msg.length)/2,"%s",msg)
	
	#Get anset, passing the initialised string as argument
	Ncurses.getstr(str)
	
	#set some attributes, see http://www.tldp.org/HOWTO/NCURSES-Programming-HOWTO/attrib.html
	Ncurses.attron(Ncurses::A_REVERSE)
	Ncurses.attron(Ncurses::A_UNDERLINE)
	Ncurses.attron(Ncurses::A_BLINK)
	
	#Display the string entered at the bottom of the screen
	Ncurses.mvprintw(row[0] - 2, 0, "you entered : %s", str)

	#Wait for a keypress to exit
	Ncurses.getch()
ensure
	Ncurses.endwin
end
