#!/usr/bin/env ruby

#based on http://www.tldp.org/HOWTO/NCURSES-Programming-HOWTO/init.html
require 'ncurses'


#Start exception handling, so we can be sure we close Ncurse in the ensure block.
#If that doesn't happen, your terminal can behave strangely.
begin 

	#Initialize screen
	Ncurses.initscr

	#Line buffering disabled
	Ncurses.raw

	#Also get Function keys
	#equivalent to keypad(stdscr,true) in C
	Ncurses.stdscr.keypad(true)

	#Don't echo() while we do getch
	Ncurses.noecho

	#print message
	Ncurses.printw("Type any character to see it in bold\n")

	#and get the first character pressed
	ch=Ncurses.getch()

	#test if we got F1
	if ch == Ncurses::KEY_F1
		Ncurses.printw("F1 pressed")
	else
		Ncurses.printw("The pressed key is ")


		#Switch  attribute bold on
		Ncurses.attron(Ncurses::A_BOLD)
		
		
		#print character, with attributes currently set
		Ncurses.printw("%c", ch)
		#equivalent to addch
		Ncurses.addch(ch)
		#and addstr (which takes a string, not the character code)
		Ncurses.addstr(ch.chr)


		#We can also use the mv* functions to output the text at a chosen coordinate:
		Ncurses.mvprintw(20,20,"%c", ch)
		Ncurses.mvaddch(21,21,ch)
		#Doest seem to exist..
#		Ncurses.mvadstr(22,22,ch.chr)

		#Switch attribute bold on
		Ncurses.attroff(Ncurses::A_BOLD)
	end

	#Refresh screen
	Ncurses.refresh

	#wait till user presses a key
	Ncurses.getch
ensure
	#Close the ncurses window
	Ncurses.endwin
end
